// ---------------------------------------------------
// Projet : Tests
// Commentaires : Envoi d'une donnée ou exécution d'une
// commande (deux boutons sur une page web)
// en réponse à une requête (REST)
// arduino/analog/val1 : lecture de l'entrée analogique 0
// arduino/analog/val2 : lecture de l'entrée analogique 1
// arduino/analog/val3 : lecture de l'entrée analogique 2
// arduino/analog/val4 : lecture de l'entrée analogique 3
// arduino/digital/13/x : x = 0 ou 1 appliqué à la pin 13
//
// Matériel : Carte Arduino Uno Wifi
// Version: 1.1
// Date: 16/3/2018
// Fichier : testUnoWifi.ino
// ---------------------------------------------------
// Bibliothèques
#include <Wire.h>
#include <UnoWiFiDevEd.h>
// ---------------------------------------------------
// Variables globales
int val1 = 0, val2 = 0, val3 = 0, val4 = 0;
// ---------------------------------------------------
void setup()
{
  Wifi.begin();
}
// ---------------------------------------------------
void loop()
{
  val1 = analogRead(0);
  val2 = analogRead(1);
  val3 = analogRead(2);
  val4 = analogRead(3);

  while (Wifi.available())
  {
    process(Wifi);
  }
  delay(50);
}
// ---------------------------------------------------
void process(WifiData client)
{
  // read the command
  String command = client.readStringUntil('/');

  // is "grandeur" command?
  if (command == "analog")
  {
    analogCommand(client);
  }
  // is "digital" command?
  if (command == "digital")
  {
    digitalCommand(client);
  }
}

// ---------------------------------------------------
void analogCommand(WifiData client)
{
  // Read command and react accordingly
  String command = client.readStringUntil('\r');

  // Return temp measurement
  if (command == "val1")
  {
    client.println("HTTP/1.1 200 OK\n");
    client.print(val1);
    client.print(EOL); //char terminator
  }

  if (command == "val2")
  {
    client.println("HTTP/1.1 200 OK\n");
    client.print(val2);
    client.print(EOL); //char terminator
  }

  if (command == "val3")
  {
    client.println("HTTP/1.1 200 OK\n");
    client.print(val3);
    client.print(EOL); //char terminator
  }

  if (command == "val4")
  {
    client.println("HTTP/1.1 200 OK\n");
    client.print(val4);
    client.print(EOL); //char terminator
  }
}
// ---------------------------------------------------
void digitalCommand(WifiData client)
{
  int pin, value;

  // Read pin number
  pin = client.parseInt();

  // If the next character is a '/' it means we have an URL
  // with a value like: "/digital/13/1"
  if (client.read() == '/')
  {
    value = client.parseInt();
    digitalWrite(pin, value);
  }
  else
  {
    value = digitalRead(pin);
  }

  // Send feedback to client
  client.println("Status: 200 OK\n");
  client.print(EOL); //char terminator
}
